// Instance ove klase konvertuju string u neki konkretan tip podataka i obratno
// Takodje je dato par gotovih implementacija konvertera
public interface Konverter<T> {

	public String toString(T element);
	public T fromString(String string);

	public static Konverter<Integer> INTEGER = new Konverter<Integer>() {
		@Override public String toString(Integer element) { return element == null ? null : element.toString(); }
		@Override public Integer fromString(String string) { return string == null ? null : Integer.parseInt(string); }
	};

	public static Konverter<Long> LONG = new Konverter<Long>() {
		@Override public String toString(Long element) { return element == null ? null : element.toString(); }
		@Override public Long fromString(String string) { return string == null ? null : Long.parseLong(string); }
	};

	public static Konverter<Double> DOUBLE = new Konverter<Double>() {
		@Override public String toString(Double element) { return element == null ? null : element.toString(); }
		@Override public Double fromString(String string) { return string == null ? null : Double.parseDouble(string); }
	};

	public static Konverter<String> STRING = new Konverter<String>() {
		@Override public String toString(String element) { return element; }
		@Override public String fromString(String string) { return string; }
	};

	public static Konverter<Osoba> OSOBA = new Konverter<Osoba>() {
		@Override public String toString(Osoba element) { return element == null ? null : element.getIme() + " " + element.getPrezime() + " " + element.getGodinaRodjenja(); }
		@Override public Osoba fromString(String string) { if (string == null) return null; else { String[] delovi = string.split(" "); return new Osoba(delovi[0], delovi[1], Integer.parseInt(delovi[2]));} }
	};
	
}
